extern sound_before_emu_routine sound_before_emu;
extern sound_after_emu_routine  sound_after_emu;


extern void timer_routine(void);
extern void timer_routine_continuous(void);

extern playbuffer_routine sound_playbuffer;

extern add_sample_to_buffer_routine config_sound_bufferroutines[16];
extern setup_soundmode_routine config_sound_setuproutines[16];

extern ULO audio_handler;
extern ULO audio_putinbuffer;
extern ULO audiocounter;

extern void sound_initmode(void);
extern ULO audio_hblanks;
extern void soundinit(void);
extern ULO config_sound_mode;
extern ULO config_sound;
extern ULO config_soundcard_found;
extern ULO config_soundmodes[16];
extern void timer_routine(void);
extern ULO configaudiomodesetbylog;

extern ULO audstatejmptable[6];
extern ULO left,right;
extern ULO sound_framecounter;

// These are external registers
extern ULO audpt[4];
extern ULO audlen[4];
extern ULO audper[4];
extern ULO audvol[4];
extern ULO auddat[4];

// These are internal registers 
extern ULO audptw[4];
extern ULO audlenw[4];  // Length counted down
extern ULO audperconstant[4]; // Period constant used for counting down percounter
extern ULO audpercounter[4];  
extern ULO auddatw[4];   // When this reg is loaded from auddat, ADL is set 
extern ULO audstate[4];
extern ULO auddma[4];
extern ULO audadl[4]; // Audio data load signal (to dma controller)
extern ULO audvolw[4]; // Internal volume control

extern ULO periodtable[65536];
extern WOR volumes[256][64];
extern UWO audioirqmask[4];
extern ULO audiodmaconmask[4];

extern void audiostate0(void);
extern void audiostate1(void);
extern void audiostate2(void);
extern void audiostate3(void);
extern void audiostate4(void);
extern void audiostate5(void);

extern void audio_frequency_handler_44100(void);
extern void audio_frequency_handler_31300(void);
extern void audio_frequency_handler_22050(void);
extern void audio_frequency_handler_15650(void);


